#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <linux/fb.h>
#include <unistd.h>
#include <stropts.h>
#include "uppermem.h"

int Uppermemfd;
void* UpperMem;

#define BLOCKSIZE 1024

int TakenSize[0x2000000 / BLOCKSIZE];

#define SetTaken(Start, Size) TakenSize[(Start - 0x2000000) / BLOCKSIZE] = (Size - 1) / BLOCKSIZE + 1

void * GP2X_UpperMalloc(size_t size) {
    int i = 0;
ReDo:
    for(; TakenSize[i]; i += TakenSize[i]){};

    if (i >= 0x2000000 / BLOCKSIZE) {
        printf("UpperMalloc out of mem!");
        return NULL;
        }
    int BSize = (size - 1) / BLOCKSIZE + 1;

    int j = 1;
    for(; j < BSize; j++) {
        if (TakenSize[i + j]) {
            i += j;
            goto ReDo; //OMG Goto, kill me.
            }
        }
    TakenSize[i] = BSize;
    void* mem = ((char*)UpperMem) + i * BLOCKSIZE;
    memset(mem, 0, size);
    return mem;
    }

//Releases UpperMalloced memory
void GP2X_UpperFree(void* mem) {
    int i = (((int)mem) - ((int)UpperMem));
    if (i < 0 || i >= 0x2000000) {
        fprintf(stderr, "UpperFree of not UpperMalloced mem: %p\n", mem);
        }
    else{
        if (i % BLOCKSIZE) {fprintf(stderr, "delete error: %p\n", mem);}
        TakenSize[i / BLOCKSIZE] = 0;
        }
    }

//Returns the size of a UpperMalloced block.
int GP2X_UpperSize(void* mem) {
    int i = (((int)mem) - ((int)UpperMem));
    if (i < 0 || i >= 0x2000000) {
        fprintf(stderr, "GetUpperSize of not UpperMalloced mem: %p\n", mem);
        return -1;
        }
    return TakenSize[i / BLOCKSIZE] * BLOCKSIZE;
    }

int GP2X_UpperInit() {
  //Try to apply MMU hack.
    int mmufd = open("/dev/mmuhack", O_RDWR);
    if(mmufd < 0) {
        system("/sbin/insmod mmuhack.o");
        mmufd = open("/dev/mmuhack", O_RDWR);
        }
    if(mmufd < 0) {return(0);}
    else{close(mmufd);}

    Uppermemfd = open("/dev/mem", O_RDWR);
    UpperMem = mmap(0, 0x2000000, PROT_READ | PROT_WRITE, MAP_SHARED, Uppermemfd, 0x2000000);

    memset(TakenSize, 0, sizeof(TakenSize));

    SetTaken(0x3000000, 0x80000); // Video decoder (you could overwrite this, but if you
                                // don't need the memory then be nice and don't)
    SetTaken(0x3101000, 153600);  // Primary frame buffer
    SetTaken(0x3381000, 153600);  // Secondary frame buffer (if you don't use it, uncomment)
    SetTaken(0x3600000, 0x8000);  // Sound buffer
    return(1);
    }

void GP2X_UpperDestroy() {
    close (Uppermemfd);
    UpperMem = NULL;
    }
